//Edited from http://mb.srb2.org/showthread.php?t=41770 without permission :X
//Gives Fang a super spring jump instead of a spindash
freeslot("sfx_pchrg", "sfx_prlse")
sfxinfo[sfx_pchrg] = {caption = "UUUUUUUU"}
sfxinfo[sfx_prlse] = {caption = "HHHHHHHH"}

addHook("ThinkFrame", do
	for player in players.iterate
	    if player.mo.chargelevel == nil
			player.mo.chargelevel = 0
		end
	end
end)

addHook("ThinkFrame", do
	for player in players.iterate
		if (player.cmd.buttons & BT_CUSTOM1)
		and P_IsObjectOnGround(player.mo)
		and (player.speed == 0)
		and player.mo.mooncharge
		if (player.mo.chargelevel < 100)
			player.mo.chargelevel = $1+1
			--print(player.mo.chargelevel)
			elseif (player.mo.chargelevel == 100)
			player.mo.chargelevel = 100
			end
		end
	end
end)

addHook("ThinkFrame", do
	for player in players.iterate
       if not (player.mo.mooncharge)
	   player.mo.chargelevel = 0
	   --print(player.mo.chargelevel)
	   end
	end
end)

addHook("ThinkFrame", do
	for player in players.iterate
	    if player.mo.skin == "snick"
		and not player.mo.mooncharge
		and (player.cmd.buttons & BT_CUSTOM1)
		and P_IsObjectOnGround(player.mo) //If player is on ground
		and (player.speed == 0) //If player not move
		S_StartSound(player.mo, sfx_pchrg)
		player.powers[pw_nocontrol] = 150000 //Player can't move when he charging
		player.mo.mooncharge = true
		--player.pflags = PF_JUMPED
		end
	end
end)

addHook("ThinkFrame", do
	for player in players.iterate
		if (player.cmd.buttons & BT_CUSTOM1)
		and (player.mo.mooncharge) //If sonic has charge moonjump
		and (player.speed == 0) //If player not move
			if (player.mo.chargelevel % 35 == 0 and player.mo.chargelevel < 100)
				S_StartSound(player.mo, sfx_pchrg)
			end
			if player.mo.chargelevel < 35
				player.mo.state = S_PLAY_BOUNCE
			else
				player.mo.state = S_PLAY_BOUNCE_LANDING
				player.mo.frame = player.mo.chargelevel / 35 - 1
			end
		end
	end
end)

addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo.mooncharge)
		and not (player.cmd.buttons & BT_CUSTOM1) //If sonic has charge moonjump
		and (player.speed == 0) //If player not move
		S_StartSound(player.mo, sfx_prlse)
		player.pflags = PF_JUMPED
		player.powers[pw_nocontrol] = 0 //Player can move again
		if player.mo.chargelevel < 35
			P_SetObjectMomZ(player.mo, 11*FRACUNIT, false) //Level 1: Blue spring height
		elseif player.mo.chargelevel < 70
			P_SetObjectMomZ(player.mo, 20*FRACUNIT, false) //Level 2: Yellow spring height
		else
			P_SetObjectMomZ(player.mo, 32*FRACUNIT, false) //Level 3: Red spring height
		end
		player.mo.mooncharge = false
		player.mo.state = S_PLAY_SPRING
		end
	end
end)
